package com.jiuqi.util.comparator;

import java.util.Comparator;

public final class ObjectComparator implements Comparator
{
    private boolean isDescOrder;
    
    public ObjectComparator() {
    }
    
    public ObjectComparator(final boolean isDescOrder) {
        this.isDescOrder = isDescOrder;
    }
    
    public int compare(final Object o1, final Object o2) {
        if (o1 == o2) {
            return 0;
        }
        int ret = 0;
        if (o1 == null) {
            ret = -1;
        }
        else if (o2 == null) {
            ret = 1;
        }
        else if (o1 instanceof Comparable) {
            ret = ((Comparable)o1).compareTo(o2);
        }
        else if (o2 instanceof Comparable) {
            ret = -((Comparable)o2).compareTo(o1);
        }
        else if (o1 instanceof Boolean && o2 instanceof Boolean) {
            ret = (((boolean)o1 - (boolean)o2) ? 1 : 0);
        }
        return this.isDescOrder ? (-ret) : ret;
    }
    
    @Override
    public boolean equals(final Object obj) {
        return this == obj || (this != null && obj != null && obj instanceof ObjectComparator && ((ObjectComparator)obj).isDescOrder == this.isDescOrder);
    }
    
    @Override
    public String toString() {
        return "[对象比较器, " + (this.isDescOrder ? "降序]" : "升序]");
    }
    
    public boolean isDescOrder() {
        return this.isDescOrder;
    }
    
    public void setDescOrder(final boolean isDescOrder) {
        this.isDescOrder = isDescOrder;
    }
}
